#include <stdio.h>
#include <stdlib.h>

#include  "output.h"
#include  "param.h"

// Load the Primary Register with a Constant
void LoadConstant(char* n)
{
	int number;

	number = atoi(n);

	if (number >= 512)
	{
		printf ("\t\t\tjmp     #lmm_load_pointer");
		printf ("\t'Primary := %s\n", n);
		printf ("\t\t\tlong    @con_%s\n", n);
		printf ("\t\t\trdlong  D0, pointer\n");
	}
	else
	{
		printf ("\t\t\tmov     D0, #%s", n);
		printf ("\t\t\t'Primary := %s\n", n);
	}

	// printf ("MOVE #%s,D0\n", n);
	// EmitLn('MOVE #' + n + ',D0' );
}

// Load a Variable to the Primary Register
void LoadVariable(char* Name)
{
	printf ("\t\t\tjmp     #lmm_load_pointer");
	printf ("\t'Primary := %s\n", Name);
	printf ("\t\t\tlong    @%s\n", Name);
	printf ("\t\t\trdlong  D0, pointer\n");

	// printf ("MOVE %s(PC),D0\n", Name);
	// EmitLn('MOVE ' + Name + '(PC),D0');
}

// Store the Primary Register to a Variable
void StoreVariable(char* Name)
{
	printf ("\t\t\tjmp     #lmm_load_pointer");
	printf ("\t'%s := Primary\n", Name);
	printf ("\t\t\tlong    @%s\n", Name);
	printf ("\t\t\twrlong  D0, pointer\n");

	// EmitLn('LEA ' + Name + '(PC),A0'); 
	// EmitLn('MOVE D0,(A0)'); 
}


// Negate Primary
void Negate() 
{
	printf ("\t\t\tneg     D0,D0");
	printf ("\t'Primary := -Primary\n");

	// EmitLn('NEG D0'); 
}

// Push Primary to Stack
void Push()
{
	printf ("\t\t\tsub     SP, #4");
	printf ("\t\t\t'Push Primary to stack\n");
	printf ("\t\t\twrlong  D0, SP\n");

	// EmitLn('MOVE D0,-(SP)'); 
}

// Add TOS to Primary
void PopAdd()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'Add Top Of Stack (TOS) to Primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tadd     D0, D1\n");

	// EmitLn('ADD (SP)+,D0'); 
}

// Subtract TOS from Primary
void PopSub()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'Subtract TOS from primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tsub     D0, D1\n");

	// EmitLn('SUB (SP)+,D0'); 
	// Negate();
}

// Or TOS with Primary
void PopOr()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'OR Top Of Stack (TOS) to Primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tor     D0, D1\n");

	// EmitLn('OR (SP)+,D0'); 
}

// Exclusive-Or TOS with Primary 
void PopXor()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'XOR Top Of Stack (TOS) to Primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\txor     D0, D1\n");

	// EmitLn('EOR (SP)+,D0'); 
}



// Multiply TOS by Primary
void PopMul()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t\t'Multiply unsigned Top Of Stack (TOS) to Primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tjmp     #mul32\n");

	// EmitLn('MULS (SP)+,D0'); 
}

// Divide Primary by TOS
void PopDiv() 
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t\t'Divide unsigned Primary by Top Of Stack (TOS)\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tjmp     #div32u\n");

	// EmitLn('MOVE (SP)+,D7'); 
	// EmitLn('EXT.L D7'); 
	// EmitLn('DIVS D0,D7'); 
	// EmitLn('MOVE D7,D0'); 
}

// And Primary with TOS
void PopAnd()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'AND Top Of Stack (TOS) to Primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tand     D0, D1\n");

	//EmitLn('AND (SP)+,D0'); 
}

// Bitwise Not Primary
void NotIt()
{
	printf ("\t\t\txor     D0, minus_one");
	printf ("\t'Bitwise Not Primary\n");
	
	//EmitLn('EOR #-1,D0'); 
}

// Call a subroutine
void Call(char* Name)
{
	printf ("\t\t\tjmp	#lmm_call");
	printf ("\t\t'Call %s\n", Name);
	printf ("\t\t\tlong    @%s\n", Name);
}

// Write Header Info
void Header()
{
	printf("\t\t\t.include \"lmm.pasm\"\n\n\n");
}

// Write the Prolog
void Prolog()
{
	printf ("PROGRAM\t\t\t\t\t\t\t'LMM Program starts here\n");

	printf ("\t\t\tjmp     #lmm_load_pointer       'Load the stack pointer\n");
	printf ("\t\t\tlong    @stack\n");
	printf ("\t\t\tmov     SP, pointer\n");


}

// Write the Epilog
void Epilog()
{
	int i;
	printf ("Epilog\n");
	for (i = 0; i < 100; i++)
	{
		printf ("\t\t\tlong\t0\n");
	}
	printf ("stack\n");
}


// Allocate Storage for a Static Variable
void Allocate(char* name, char* val)
{
	printf ("%s\t\t\tlong\t%s\n", name, val);

	// WriteLn(Name, ':', TAB, 'DC ', Val);
}

// Read Variable to Primary Register and store to variable
void ReadIt()
{
	printf ("\t\t\tmov     D0, ina");
	printf ("\t\t\t'Read primary\n");
	
	// EmitLn('BSR READ');
	// Store(Name);
}

// Write from Primary Register
void WriteIt()
{
	printf ("\t\t\trol     D0, #8");
	printf ("\t\t\t'Write primary\n");
	printf ("\t\t\tmov     outa, D0\n");
	printf ("\t\t\tror     D0, #8\n");
	//printf ("\t\t\tjmp     #lmm_halt\n");


	// EmitLn('BSR WRITE');
}

// Branch False
void  BranchFalse(char* L)
{
	printf ("\t\t\tjmp	#lmm_jmp_z");
	printf ("\t\t'Branch false %s\n", L);
	printf ("\t\t\tlong    @%s\n", L);

	// EmitLn('TST D0');
	// EmitLn('BEQ ' + L);
}

// Branch Unconditional
void Branch(char* L)
{
	printf ("\t\t\tjmp	#lmm_jmp");
	printf ("\t\t'Branch unconditional %s\n", L);
	printf ("\t\t\tlong    @%s\n", L);

	// EmitLn('BRA ' + L);
}

// Post a Label To Output
void PostLabel(char* L)
{
	printf ("%s\n", L);

	// WriteLn(L, ':');
}


// Set Primary If Compare was =
void SetEqual()
{
	printf ("\t\t\tmov	D0, #0");
	printf ("\t\t\t'Set equal\n");
	printf ("\t\tif_e\tmov	D0, minus_one wz\n");

	// EmitLn('SEQ D0');
	// EmitLn('EXT D0');
}

// Compare Top of Stack with Primary
void PopCompare()
{
	printf ("\t\t\trdlong  D1, SP");
	printf ("\t\t'Compare TOS with primary\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tcmp     D0, D1 wz, wc\n");

	// EmitLn('CMP (SP)+,D0');
}

// Set Primary If Compare was <=
void SetLessOrEqual()
{
	printf ("\t\t\tmov	D0, #0");
	printf ("\t\t\t'Set less or equal\n");
	printf ("\t\tif_be\tmov	D0, minus_one wz\n");

	// EmitLn('SGE D0');
	// EmitLn('EXT D0');
}

// Set Primary If Compare was >=
void SetGreaterOrEqual()
{
	printf ("\t\t\tmov	D0, #0");
	printf ("\t\t\t'Set greater or equal\n");
	printf ("\t\tif_ae\tmov	D0, minus_one wz\n");

	// EmitLn('SLE D0');
	// EmitLn('EXT D0');
}

// Set Primary If Compare was !=
void SetNEqual()
{
	printf ("\t\t\tmov	D0, #0");
	printf ("\t\t\t'Set not equal\n");
	printf ("\t\tif_ne\tmov	D0, minus_one wz\n");

	// EmitLn('SNE D0');
	// EmitLn('EXT D0');
}

// Set Primary If Compare was <
void SetLess()
{
	printf ("\t\t\tmov	D0, #0");
	printf ("\t\t\t'Set less\n");
	printf ("\t\tif_b\tmov	D0, minus_one wz\n");

	// EmitLn('SGT D0');
	// EmitLn('EXT D0');
}


// Set Primary If Compare was >
void SetGreater()
{
	printf ("\t\tif_be mov	D0, #0");
	printf ("\t\t\t'Set greater\n");
	printf ("\t\tif_a\tmov	D0, minus_one wz\n");

	// EmitLn('SGT D0');
	// EmitLn('EXT D0');
}

// Clear the Primary Register
void Clear()
{
	printf ("Clear:\n");
	// EmitLn('CLR D0');
}



// Load a Parameter to the Primary Register
void LoadParam(int N)
{
	int Offset;

	Offset = 4 + 4 * (Base - N);

	printf ("\t\t\tmov	A1, SF\t\t\t'Load parameter %d to primary\n", N);
	if (Offset >= 0)
	{
		printf ("\t\t\tadd	A1, #%d\n", Offset);
	}
	else
	{
		printf ("\t\t\tsub	A1, #%d\n", -Offset);
	}
	printf ("\t\t\trdlong	D0, A1\n");

	// Emit('MOVE ');
	// WriteLn(Offset, '(SP),D0');
}


// Store a Parameter from the Primary Register
void StoreParam(int N)
{
	int Offset;

	Offset = 4 + 4 * (Base - N);

	printf ("\t\t\tmov	A1, SF\t\t\t'Store parameter %d from primary\n", N);
	if (Offset >= 0)
	{
		printf ("\t\t\tadd	A1, #%d\n", Offset);
	}
	else
	{
		printf ("\t\t\tsub	A1, #%d\n", -Offset);
	}
	printf ("\t\t\twrlong	D0, A1\n");

	// Emit('MOVE D0,');
	// WriteLn(Offset, '(SP)');
}


// Adjust the Stack Pointer Upwards by N Bytes
void CleanStack(int N)
{
	if (N > 0)
	{
		printf ("\t\t\tadd     SP, #%d\t\t\t'Clean stack %d bytes\n", N, N);

		// Emit('ADD #');
		// WriteLn(N, ',SP');

	}
}

// Write the Prolog for a Procedure
void ProcProlog(char* L, int k)
{
	PostLabel(L);

	int localsBytes = k * 4; 

	printf ("\t\t\tsub     SP, #4");
	printf ("\t\t\t'LINK SF\n");
	printf ("\t\t\twrlong  SF, SP\n");
	printf ("\t\t\tmov     SF, SP\n");
	printf ("\t\t\tsub     SP, #%d\n", localsBytes);

	// EmitLn('LINK A6,#0');
}


// Write the Epilog for a Procedure
void ProcEpilog()
{
	printf ("\t\t\tmov     SP, SF");
	printf ("\t\t\t'UNLINK SF\n");
	printf ("\t\t\trdlong  SF, SP\n");
	printf ("\t\t\tadd     SP, #4\n");
	printf ("\t\t\tjmp	#lmm_ret\t\t'Return\n");

	// EmitLn('UNLK A6');
	// EmitLn('RTS');
}
