#ifndef SCANNER_H
#define SCANNER_H

// Enumeration of language keywords (KW_X is not a keyword)
enum KEY_WORD {KW_X, KW_IF, KW_ELSE, KW_ENDIF, KW_WHILE, KW_ENDWHILE, KW_READ, KW_WRITE, KW_VAR, KW_END, KW_PROGRAM, KW_PROCEDURE, KW_FUNCTION};

// Recognize an Alpha Character
int IsAlpha(char c);

// Recognize a Numeric Character
int  IsDigit(char c);

// Recognize an Alphanumeric Character
int IsAlnum(char c);

// Recognize an Addition Operator
int IsAddop(char c);

// Recognize a Multiplication Operator 
int IsMulop(char c);

// Recognize a Boolean Orop
int IsOrOp(char c);

// Recognize White Space
int IsWhite(char c);

// Skip Over Leading White Space
void SkipWhite();


// Match One Character
void Match(char c);

// Match a Specific Input String
void MatchString(char* x);

// Match a Semicolon
void Semi();


// Get an Identifier
void GetName();

// Get a Number 
#ifdef numbers_as_integers 
//int GetNumber();
#else
char* GetNumber();
#endif

extern char Token;
extern char Value[33];

// Get the Next Input Token
void Next();

// Scan the Current Identifier for Keywords
void Scan();

// Recognize a Relop
int IsRelop(char c);

#endif
